program dechiff;

uses crt;

const
  maxzeilenzahl=6;
  maxzeichenzahl=120;

var
  ge,kl:text;
  gedateiname,kldateiname:string[12];
  zeile,neuzeile:array[0..maxzeilenzahl] of string[255];
  n:array[0..30] of longint;
  nmerk:longint;
  z,zg,zk:array[0..maxzeichenzahl] of char;
  wunsch,zmerk,gezeichen,klzeichen,z1,z2:char;
  anfang,ende,zeilenzahl,tauschzahl:integer;
  start,fehler:boolean;

procedure sortieren;
var
  i,j:integer;
begin
  for i:=1 to 30-1 do
    for j:=i+1 to 30 do
      if n[i]<n[j] then
      begin
        nmerk:=n[i];
        n[i]:=n[j];
        n[j]:=nmerk;
        zmerk:=z[i];
        z[i]:=z[j];
        z[j]:=zmerk
      end
end;

procedure erste_zeilen;
var
  i,j:integer;
  ersetzt:boolean;
begin
  window(1,1,80,3);
  clrscr;
  writeln('Buchstaben in der Reihenfolge der Hufigkeit in der Geheimtextdatei');
  write(gedateiname,':  ');
  for i:=1 to 30 do write(z[i],' ');
  gotoxy(length(gedateiname)+4,3);
  for i:=1 to 30 do
  if tauschzahl>0 then
  begin
    j:=0;
    ersetzt:=false;
    repeat
      j:=j+1;
      if (zg[j]=z[i]) and (zk[j]<>'_') then ersetzt:=true
    until (j=tauschzahl) or ersetzt;
    if ersetzt then write(zk[j],' ') else write('_ ')
  end;
  window(1,1,80,25)
end;

procedure ausgabe_tabelle;
var
  i:integer;
begin
  sortieren;
  window(1,1,80,25);
  clrscr;
  writeln('Sortierte Buchstabenanteile im Geheimtext ',gedateiname);
  writeln('Angabe in % :');writeln;
  if n[0]>0 then
    for i:=1 to 15 do
      writeln(z[i],n[i]/n[0]*100:10:2,z[i+15]:10,n[i+15]/n[0]*100:10:2);
  writeln;
  writeln(n[0],' Buchstaben');writeln;
  write('Drcken Sie RETURN: ');readln;
  if n[0]>0 then erste_zeilen
end;

procedure statistik;
var
   i,j:integer;
begin
  for i:=1 to 26 do z[i]:=chr(i+64); (*Grossbuchstaben*)
  z[27]:='';
  z[28]:='';
  z[29]:='';
  assign(ge,gedateiname);
  reset(ge);
  for i:=0 to 30 do n[i]:=0;
  while not eof(ge) do
  begin
    readln(ge,zeile[0]);
    for i:=1 to length(zeile[0]) do
    begin
      j:=0;
      repeat j:=j+1 until (z[j]=zeile[0][i]) or (j=30);
      if j<30 then n[j]:=n[j]+1
    end
  end;
  close(ge);
  for i:=1 to 26 do z[i]:=chr(i+96); (*Kleinbuchstaben*)
  z[27]:='';
  z[28]:='';
  z[29]:='';
  z[30]:='';
  assign(ge,gedateiname);
  reset(ge);
  while not eof(ge) do
  begin
    readln(ge,zeile[0]);
    for i:=1 to length(zeile[0]) do
    begin
      j:=0;
      repeat j:=j+1 until (z[j]=zeile[0][i]) or (j=31);
      if j<31 then n[j]:=n[j]+1
    end
  end;
  close(ge);
  for i:=1 to 30 do n[0]:=n[0]+n[i];
  ausgabe_tabelle
end;

procedure neuzeilen_machen;
var
  i,j:integer;
begin
  for i:=1 to maxzeilenzahl do
  begin
    neuzeile[i]:='';
    for j:=1 to length(zeile[i]) do neuzeile[i]:=concat(neuzeile[i],'_')
  end
end;

procedure speichern;
var
  dateida,zurueck:boolean;
  i:integer;
begin
  clrscr;
  dateida:=false;
  zurueck:=false;
  clrscr;
  gotoxy(1,2);
  writeln('Es werden im folgenden nur die gerade sichtbaren Klartextzeilen gespeichert!');
  write('Dateinamen fr Klartext eingeben (oder zurck mit RETURN): ');
  readln(kldateiname);
  if length(kldateiname)=0 then zurueck:=true;
  if not zurueck then
  begin
    assign(kl,kldateiname);
    {$I-} reset(kl); {$I+}
    if ioresult=0 then
    begin
      close(kl);
      clrscr;
      gotoxy(1,2);
      writeln('Eine Datei des Namens ',kldateiname,' existiert schon!');
      if gedateiname=kldateiname then
      begin
        write('Da sie den Geheimtext enthlt, wird nicht gespeichert! Drcken Sie RETURN: ');
        zurueck:=true
      end
      else write('Wenn der Text hinten angehngt werden soll, dann + drcken (sonst RETURN): ');
      repeat until keypressed;
      wunsch:=readkey;
      if (wunsch='+') and not zurueck then dateida:=true else zurueck:=true
    end;
    if not zurueck then
    begin
      assign(kl,kldateiname);
      if dateida then
      begin
        reset(kl);
        while not eof(kl) do readln(kl,zeile[0])
      end
      else rewrite(kl);
      append(kl);
      for i:=1 to ende-anfang+1 do writeln(kl,neuzeile[i]);
      close(kl);
      clrscr;
      gotoxy(1,2);
      if dateida then writeln ('Die Datei ',kldateiname,
                               ' wurde um die sichtbaren Klartextzeilen ergnzt!')
      else writeln('Die sichtbaren Klartextzeilen wurden in der neuen Datei ',
                    kldateiname,' gespeichert!');
      write('Drcken Sie RETURN: ');readln
    end
  end
end;

procedure buchstaben_ersetzen;
var
  i,j:integer;
  neuzeichen:boolean;
begin
  clrscr;
  gotoxy(1,2);
  write('Zu ersetzender Geheimtextbuchstabe: ');
  repeat until keypressed;
  gezeichen:=readkey;
  write(gezeichen);
  writeln;
  write('Einzusetzender Klartextbuchstabe:   ');
  repeat until keypressed;
  klzeichen:=readkey;
  write(klzeichen);
  if (gezeichen<>chr(13)) and (klzeichen<>chr(13)) then
  begin
    for i:=1 to ende-anfang+1 do
      for j:=1 to length(zeile[i]) do
      if zeile[i][j]=gezeichen then
        neuzeile[i]:=concat(copy(neuzeile[i],1,j-1),klzeichen,copy(neuzeile[i],j+1,length(neuzeile[i])));
    tauschzahl:=tauschzahl+1;
    neuzeichen:=true;
    i:=0;
    repeat
      i:=i+1;
      if gezeichen=zg[i] then
      begin
        tauschzahl:=tauschzahl-1;
        zk[i]:=klzeichen;
        neuzeichen:=false
      end
    until (i=tauschzahl) or not neuzeichen;
    if neuzeichen then
    begin
      zg[tauschzahl]:=gezeichen;
      zk[tauschzahl]:=klzeichen
    end;
    fehler:=false;
    if tauschzahl>1 then
    for i:=1 to tauschzahl-1 do
      for j:=i+1 to tauschzahl do
      if (zk[i]=zk[j]) and (zk[i]<>'_') then
      begin
        fehler:=true;
        z1:=zg[i];
        z2:=zg[j]
      end
  end
end;

function minimum(x,y:integer):integer;
begin
  if x<y then minimum:=x
  else minimum:=y
end;

procedure zeileneingabe;
var
  i:integer;
begin
  gotoxy(1,2);
  if not start then
  begin
    anfang:=0;ende:=0;
    repeat
      write('Geben Sie die erste Zeilennummer ein (zwischen 1 und ',zeilenzahl,'): ');
      readln(anfang)
    until (anfang>0) and (anfang<=zeilenzahl);
    repeat
      write('Geben Sie die letzte Zeilennummer ein (zwischen ',anfang,' und ',
             minimum(anfang+maxzeilenzahl-1,zeilenzahl),'): ');
      readln(ende)
    until (anfang<=ende) and (ende<=zeilenzahl) and (ende-anfang+1<=maxzeilenzahl)
  end
  else
  begin
    start:=false;
    anfang:=1;
    ende:=minimum(maxzeilenzahl,zeilenzahl)
  end;
  assign(ge,gedateiname);
  reset(ge);
  i:=0;
  if anfang>1 then
  repeat
    repeat readln(ge,zeile[0]) until length(zeile[0])>0;
    i:=i+1
  until i=anfang-1;
  for i:=1 to ende-anfang+1 do repeat readln(ge,zeile[i]) until length(zeile[i])>0;
  close(ge)
end;

procedure andere_zeilen;
var
  i,j,k:integer;
begin
  clrscr;
  zeileneingabe;
  neuzeilen_machen;
  for i:=1 to ende-anfang+1 do
    for j:=1 to length(zeile[i]) do
      for k:=1 to tauschzahl do
        if zeile[i][j]=zg[k] then
          neuzeile[i]:=
          concat(copy(neuzeile[i],1,j-1),zk[k],copy(neuzeile[i],j+1,length(neuzeile[i])))
end;

procedure untermenu;
var
  i:integer;
begin
  neuzeilen_machen;
  repeat
    erste_zeilen;
    window(1,4,80,22);
    clrscr;
    gotoxy(1,22);
    for i:=1 to ende-anfang+1 do
    begin
      writeln('Zeile ',anfang+i-1,' (von ',zeilenzahl,'):');
      writeln(zeile[i]);
      writeln(neuzeile[i])
    end;
    window(1,22,80,25);
    clrscr;
    if fehler then
    begin
      textcolor(white+128);
      writeln('Sie haben "',z1,'" und "',z2,'" dasselbe Klartextzeichen zugeordnet!');
      textcolor(white)
    end
    else writeln;
    write('(1) Buchstaben ersetzen');
    write('(5) Statistik zeigen':23);
    writeln('(9) Entschlsselung beenden':31);
    write('(3) andere Zeilen zeigen');
    write('(7) Klartext speichern':24);
    write('Whlen Sie: ':14);
    repeat until keypressed;
    wunsch:=readkey;
    case wunsch of
    '1': buchstaben_ersetzen;
    '3': andere_zeilen;
    '5': statistik;
    '7': speichern
    end (*case*)
  until wunsch='9';
  window(1,1,80,25)
end;

procedure ausfuehrung;
var
  i:integer;
begin
  for i:=1 to maxzeichenzahl do
  begin
    zg[i]:=' ';
    zk[i]:=' '
  end;
  statistik;
  if n[0]>0 then
  begin
    assign(ge,gedateiname);
    reset(ge);
    i:=0;
    repeat
      repeat readln(ge,zeile[0]) until (length(zeile[0])>0) or eof(ge);
      i:=i+1;
      if (length(zeile[0])=0) and eof(ge) then i:=i-1
    until eof(ge);
    close(ge);
    zeilenzahl:=i;
    clrscr;
    writeln('Im Programm werden maximal ',maxzeilenzahl,' Zeilen gleichzeitig betrachtet,');
    writeln('bei berlangen Zeilen entsprechend weniger.');
    writeln('Man kann jedoch umfangreichere Texte paketweise bearbeiten.');writeln;
    writeln('Das Programm geht davon aus, das die Entschlsselung eines Zeichens stets');
    writeln('fr den gesamten Text gemeint ist (monoalphabetische Verschlsselung!).');
    writeln('Sie kann aber whrend der Sitzung in beliebigem Textbereich beliebig');
    writeln('korrigiert bzw. rckgngig gemacht werden.');writeln;
    writeln('Auch wenn die Buchstabenstatistik nur deutsche Buchstaben (klein und gro)');
    writeln('bercksichtigt, werden andere Tastaturzeichen verarbeitet.');writeln;
    writeln;writeln;writeln;writeln;
    writeln('Die aktuelle Datei ',gedateiname,' enthlt ',zeilenzahl,' echte Textzeilen.');
    writeln;
    writeln('Dabei gilt allerdings auch jede Folge von Leerzeichen als Text.');
    writeln('Ggf. sollte man unntige oder strende Leerzeichen vor der Entschlsselung');
    writeln('aus dem Geheimtext entfernen.');writeln;
    write('Drcken Sie RETURN: ');readln;
    zeileneingabe;
    untermenu
  end
  else
  begin
    writeln;
    writeln('Ein Text von 0 Zeichen wird immer ein Geheimnis bleiben!');writeln;
    write('Drcken Sie RETURN: ');readln
  end
end;

begin
  textbackground(blue);
  textcolor(white);
  repeat
    start:=true;
    kldateiname:='';
    tauschzahl:=0;
    fehler:=false;
    clrscr;
    writeln('Programm zur K R Y P T O L O G I E:');
    writeln('===================================');writeln;
    writeln('E n t schlsselung eines monoalphabetisch  v e r schlsselten Textes');
    gotoxy(1,9);
    writeln('Der Geheimtext sollte im ASCII-Format vorliegen.');writeln;
    writeln('Als Hilfsmittel dient die Buchstabenstatistik des Geheimtextes.');
    writeln('Die Auswertung erfolgt fr die Buchstaben');
    writeln('a bis z, , , ,  des deutschen Alphabets,');
    writeln('wobei groe und kleine Zeichen nicht unterschieden werden.');
    writeln;
    writeln('<g> Datei mit Geheimtext aufrufen');writeln;
    writeln('<e> Programmende');writeln;
    write('Ihr Wunsch: ');
    repeat until keypressed;writeln;
    wunsch:=readkey;
    if wunsch='g' then
    begin
      writeln;
      write('Namen der Geheimtextdatei eingeben (oder zurck mit RETURN): ');
      readln(gedateiname);
      writeln;
      if length(gedateiname)<>0 then
      begin
        assign(ge,gedateiname);
        {$I-} reset(ge); {$I+}
        if ioresult=0 then
        begin
          close(ge);
          ausfuehrung
        end
        else
        begin
          write('Die Datei ',gedateiname,' wird nicht gefunden! Drcken Sie RETURN: ');
          readln
        end
      end
    end
  until wunsch='e';
  normvideo;
  clrscr
end.
(* Version vom 17.9.1996 Volker Franz *)
